/*
	Name: Cornacchia_Prime Algorithm
    This is an adaptation of MIT "Cornacchia algorithm"
	My aim here was to have a Number Field 'K' as a subfield of the complex numbers C
	This is due to 1(mod 8) and Gaussian Primes. See "THE GAUSSIAN INTEGERS" by KEITH CONRAD
	Basically there should be found, an 'order',odd, 1(mod 8). See
    "A NEW CLASS OF MODULAR EQUATION FOR WEBER FUNCTIONS" by WILLIAM B.HART. For indications
	on how it fits into "Elliptic Curves" MIT OpenCourseWare.
    It seems however to be Gaussian Primes. Hence 'K' as a subfield of the complex numbers C.
    As checked for 'Henry Cohen' example x^2 + 2y^2 = 97
    page 35 "A course in computational algebraic number theory"
	Could use "Try Catch" Error coding.
	Warren for Website "TopQuantumFusion". 12/11/2023. 
*/

#include<iostream>
#include<math.h>
#include <vector>
using namespace std;
typedef long long int DP4;

DP4 Cornacchia_Subfield_C(int d ,int m)
{
	int r1m = m;  //prime ?
	int r1m1 = m/2;
	int r2m = 0;
	int Min_Div1 = 0;
	int temp_rm1a = 0;
	int temp_rm2b = 0;
	int temp_rm3r = 0;
	int lob = 0;
	int Ceat = 0;
	int SqrtNum1 = 0;
	int XNum1 = 0;
	int YNum1 = 0;
	int Cao_d = d;
	for(r2m = 1; r2m <= r1m1; r2m++){        //Step 1
		if(((r2m*r2m) % r1m) == (r1m - d)){  //r2m is modular square root
			Min_Div1 = ((r2m*r2m) % r1m); //Min Divisor or K subfield of complex number ?//
			break;
		}
		if(r2m > r1m1){
			cout<< "Solution-less Exit"<< endl;
		}
	}
//       Step2 Algorithm Euclidean
    if(0 < r2m < r1m1){
	temp_rm1a = r1m; //prime
	temp_rm2b = r2m;
	temp_rm3r = Min_Div1;
	lob = sqrt(Min_Div1);
	}
	else{ 
	cout<< "Adjusted Modular Square Root, not in prime range"<< endl;}
	while (temp_rm3r > lob) {
		temp_rm3r = (temp_rm1a % temp_rm2b);
		temp_rm1a = temp_rm2b;
		temp_rm2b = temp_rm3r;
		}
	Ceat = ((r1m - (temp_rm3r * temp_rm3r)) / Cao_d);
	SqrtNum1 = sqrt(Ceat);
		if(SqrtNum1 == floor(SqrtNum1)){
		XNum1 = temp_rm3r;
		YNum1 = SqrtNum1;
		cout<< " x  = " << XNum1 << endl;
		cout<< " y  = " << YNum1 << endl;}
		else{cout<<"No unique solution, not a square";} 	
		return 0;	
}	

int main()
{

	DP4 t_d;
    DP4 t_m;
    cout << "Enter d an integer" << endl;
	cin >> t_d;
    cout << "Enter m an integer, typically a prime" << endl;
    cin >> t_m;
	
	Cornacchia_Subfield_C(t_d, t_m);

}
